Name:		wlan-ng
Version:	0.2.5
Release:	7%{?dist}
Summary:	Kernel module and Diagnostic tools for Prism wireless devices
Group:		System Environment/Base
License:	GPL
URL:		http://www.linux-wlan.com/linux-wlan/
Source0:	ftp://ftp.linux-wlan.org/pub/linux-wlan-ng/linux-%{name}-%{version}.tar.bz2
Source1:	ifcfg-wlan0-wlan-ng
Patch0:		linux-wlan-ng-0.2.5-kernel-2.6.19.patch
Patch1:		linux-wlan-ng-0.2.5-sandbox.patch
patch3: 	http://patches.aircrack-ng.org/linux-wlan-0.2.3.packet.injection.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	openssl-devel
BuildRequires:	kernel-devel
Provides:	wlan-ng-kmod-common = %{version}
Requires:	wlan-ng-kmod >= %{version}
BuildRequires:	qt-devel >= 3.2.1

Requires(pre): /sbin/service
Requires(pre): /sbin/chkconfig
Requires(post): /sbin/service
Requires(post): /sbin/chkconfig


%description
This package contains the  wlan-ng Driver for WiFi, a linux
device driver for 802.11a/b universal NIC cards - either Cardbus,
PCI or MiniPCI - that use the Prism 2/2.5/3 chipsets.

This is the wlan-ng-kmod-common package.

%package devel
Summary:	Development files for wlan-ng
Group:		Development/Libraries
#Requires:	%{name} = %{version}-%{release} 

%description devel
This package contains development files for %{name}.

%prep
%setup -q -n linux-%{name}-%{version}
%patch0 -p0
%patch1 -p1
%patch3 -p1

## Change path from /sbin to /usr/sbin for wlan-ng utilities.
sed -i -e 's|/sbin/wlanctl-ng|%{_sbindir}/wlanctl-ng|' etc/wlan/shared
sed -i -e 's|#FIRMWARE_DIR="/usr/share/linux-wlan"|FIRMWARE_DIR="/lib/firmware"|' etc/wlan/shared

#Both README.firmware in /lib/firmware and doc 
install -m 0644 src/prism2/README.firmware README-prism.firmware
ln -s /lib/firmware/README-prism.firmware README.firmware

cat << EOF > default.config
PRISM2_PCMCIA=y
PRISM2_PLX=n
PRISM2_PCI=n
PRISM2_USB=y
TARGET_ROOT_ON_HOST=${RPM_BUILD_ROOT}
TARGET_INST_EXEDIR=${RPM_BUILD_ROOT}%{_sbindir}
INSTALL_DEPMOD=n
PREFIX=%{_prefix}
INST_EXEDIR=%{_sbindir}
FIRMWARE_DIR=/lib/firmware/
EOF

cat <<EOF > wlan-ng-modprobe.d
# wlan-ng wireless
# kwizart
#alias wlan0 prism2_pci
alias wlan0 prism2_usb
#options prism2_pci auntocreate=sta
options prism2_usb prism2_doreset=1
EOF

make default_config

%build
pushd add-ons/keygen
make
popd
pushd add-ons/lwepgen
gcc -Wl,%{_libdir}/libcrypto.so -o lwepgen lwepgen.c
popd
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
#install -d $RPM_BUILD_ROOT%{_sysconfdir}/hotplug
make DESTDIR=$RPM_BUILD_ROOT FIRMWARE_DIR="/lib/firmware" install
pushd etc
make install
popd

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d
#mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/hotplug/usb
install -m 0644 etc/udev/rules.d/40-prism2.rules $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/
#install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/hotplug/usb/wusb11
install -D -p -m 0755 add-ons/keygen/keygen $RPM_BUILD_ROOT%{_sbindir}/keygen
install -D -p -m 0755 add-ons/lwepgen/lwepgen $RPM_BUILD_ROOT%{_sbindir}/lwepgen
install -D -p -m 0644 wlan-ng-modprobe.d $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/wlan-ng
install -d $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/network-scripts
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/network-scripts/ifcfg-wlan0
rm -rf $RPM_BUILD_ROOT/lib/modules
gzip $RPM_BUILD_ROOT/usr/local/man/man1/nwepgen.1
gzip $RPM_BUILD_ROOT/usr/local/man/man1/wland.1
gzip $RPM_BUILD_ROOT/usr/local/man/man1/wlancfg.1
gzip $RPM_BUILD_ROOT/usr/local/man/man1/wlanctl-ng.1
gzip $RPM_BUILD_ROOT/usr/local/man/man1/prism2dl.1
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mv $RPM_BUILD_ROOT/usr/local/man/man1/*.gz $RPM_BUILD_ROOT%{_mandir}/man1/
rm -rf $RPM_BUILD_ROOT/usr/local/man/man1
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/
mv $RPM_BUILD_ROOT/init.d/wlan $RPM_BUILD_ROOT%{_initrddir}/wlan-ng
rm -rf $RPM_BUILD_ROOT/init.d
install -m 0644 README-prism.firmware $RPM_BUILD_ROOT/lib/firmware

#devel
install -d $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp
install -m 0644 src/include/wlan/*.h $RPM_BUILD_ROOT%{_includedir}/wlan-ng/
#for dir in "mkmeta/obj nwepgen p80211 prism2/driver prism2/download wlancfg wlanctl";do
#install -d $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/$(dir)
#done
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/mkmeta
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/mkmeta/obj
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/nwepgen
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/p80211
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/prism2
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/prism2/driver
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/prism2/download
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/wlanctl
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/wlancfg
mkdir $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/shared

pushd src
for i in $(find * -name *.o);do
install -m 0644 ${i} $RPM_BUILD_ROOT%{_includedir}/wlan-ng/.tmp/${i}
done
popd


#Fix perms
#chmod 755 $RPM_BUILD_ROOT%{_sysconfdir}/wlan/*

#Fix resulant error
sed -i -e 's|PRISM2DL=/sbin/prism2dl|PRISM2DL=%{_sbindir}/prism2dl|' $RPM_BUILD_ROOT%{_sysconfdir}/wlan/shared.prism2
sed -i -e 's|FIRMWARE_DIR=/etc/wlan/||' $RPM_BUILD_ROOT%{_sysconfdir}/wlan/shared

%clean
rm -rf $RPM_BUILD_ROOT


%post
if [ $1 -eq 1 ]; then
#	%{_initrddir}%{name} start > /dev/null 2>&1
	/sbin/chkconfig --add 345 %{name}
fi

%preun
if [ "$1" = 0 ] ; then
	%{_initrddir}%{name} stop > /dev/null 2>&1
	/sbin/chkconfig --del %{name}
fi
exit 0 

%files
%defattr(-,root,root,-)
%doc THANKS CHANGES FAQ LICENSE TODO README COPYING doc README.firmware
%config(noreplace) %{_sysconfdir}/modprobe.d/wlan-ng
%config(noreplace) %{_sysconfdir}/sysconfig/network-scripts/ifcfg-wlan0
%config(noreplace) %{_sysconfdir}/udev/rules.d/*
#%config(noreplace) %{_sysconfdir}/hotplug/usb/wusb11
#%{_sysconfdir}/hotplug/wlan.agent
%{_sysconfdir}/wlan/wlancfg-DEFAULT
%{_sysconfdir}/wlan/wlan.conf
%{_sysconfdir}/wlan/shared*
%{_sysconfdir}/wlan/wlan-udev.sh
%{_sysconfdir}/pcmcia/wlan-ng*
%{_initrddir}/wlan-ng
%{_sbindir}/*
%{_mandir}/man1/*.gz
/lib/firmware/*

%files devel
%defattr(-,root,root,-)
%doc src/README
%{_includedir}/wlan-ng/*.h
%{_includedir}/wlan-ng/.tmp/*

%changelog
* Mon Jan  1 2007 kwizart < kwizart at gmail .com > - 0.2.5-7
- Change /sbin /usr/sbin
- fix some permssion and config
- fix firmware loading in good place /lib/firmware

* Wed Dec 27 2006 kwizart < kwizart at gmail .com > - 0.2.5-6.kwizart.fc6
- fix build on 2.6.19
- Enabled PCMCIA PLX PCI
- Enabled devel
- Enabled add-ons
- Use udev rules (TODO: hotplug ?)
- Use wlan.agent (Usefull ?)

* Sat Nov 24 2006 kwizart < kwizart at gmail .com > - 0.2.5-5.kwizart.fc6
- fix build on 2.6.18

* Sun Sep 24 2006 kwizart < kwizat at gmail.com > - 0.2.5-4.kwizart.FC5
- Update to 0.2.5

* Wed Sep 13 2006 kwizart < kwizart at gmail.com > - 0.2.3-3.kwizart.FC5
- Rename config files
- Add post & preun

* Thu Sep 07 2006 kwizart < kwizart at gmail.com > - 0.2.3-2.kwizart.FC5
- kmod-common fixed.
- now includes firmware.

* Sat Jul 24 2006 kwizart at < fedora-france.org >
- inital release ( based on madwifi from livna.org )
    with help W. Michael Petullo <mike[at]flyn.org>

